'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.validateOptions = validateOptions;
exports.forEach = forEach;

function isValidRegExp(value) {
    return value instanceof RegExp;
}

function isFunction(value) {
    return typeof value === 'function';
}

/**
 * Validate plugin options.
 */
function validateOptions(options) {
    var pattern = options.pattern,
        process = options.process;


    return isValidRegExp(pattern) && isFunction(process);
}

/**
 * Loop through each key of an object.
 *
 * @param object
 * @param callback
 */
function forEach(object, callback) {
    for (var key in object) {
        if (!object.hasOwnProperty(key)) {
            continue;
        }

        callback(object[key], key);
    }
}